<?php

namespace Drupal\exclusiv_access\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'exclusiv_access_field_widget' widget.
 *
 * @FieldWidget(
 *   id = "exclusiv_access_field_widget",
 *   label = @Translation("Exclusiv access"),
 *   field_types = {
 *     "exclusiv_access_field_type"
 *   }
 * )
 */
class ExclusivAccessFieldWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {

    $element += [
      '#type' => 'details',
    ];

    $element['#title'] = $this->t('Exclusiv Access Control');

    $element['value'] = [
      '#type' => 'checkbox',
      '#title' => 'activate',
      '#default_value' => isset($items[$delta]->value) ? $items[$delta]->value : FALSE,
    ];

    $state = \Drupal::state()->get('exclusiv_access');

    $entity_type = $items->getEntity()->getEntityType()->id();
    $entity_id = $items->getEntity()->id();

    if ($entity_id != NULL) {
      if (isset($state[$entity_type][$entity_id])) {
        $element['token'] = [
          '#title' => 'token',
          '#type' => 'textfield',
          '#default_value' => $state[$entity_type][$entity_id],
          '#disabled' => TRUE,
        ];
      }
    }

    $element['#group'] = 'advanced';

    return $element;
  }

}
